'---------------------------------------------------------------
'Digital Oscilloscope <Oscope.bas>
'Programmer: Behnam Zakizadeh
'Compiler : BASCOM 1.11.9.1
'Creation Date: 04.Dec.2010
'Copyright: (C) 2009 By www.avr64.com
'Ver: 2.02
'Last change: 15.July.2011 {Correct LCD Pins, Crystal value, Keys}
'Recompile with Bascom 2.0.7.6
'Last Edit: 15.03.1392

'ver: 3.0
'1395.07.21 [2016]

'---------------------------------------------------------------

$regfile = "m8adef.dat"
$crystal = 11059200
$hwstack = 64
$swstack = 64
$framesize = 64


$prog &HC0 , &HBF , &HD1 , &H00


'GLCD
$lib "glcdKS108.lbx"
Config Graphlcd = 128 * 64sed , Dataport = Portd , Controlport = Portb , _
 Ce = 1 , Ce2 = 0 , Cd = 5 , Rd = 4 , Reset = 2 , Enable = 3
Setfont My6_8

'A2D
Config Adc = Single , Prescaler = Auto , Reference = Internal
Enable Adc
Start Adc

'I/O
'Config Pina.1 = Input                                       'K1
'Config Pina.2 = Input                                       'K2
'Config Pina.3 = Input                                       'K3
'Config Pina.4 = Input                                       'K4
'Set Porta.1                                                 'Set Pullup Res
'Set Porta.2                                                 '//
'Set Porta.3                                                 '//
'Set Porta.4                                                 '//

Config Base = 0                                             'array start with 0

'Variables
Dim A As Word , B As Word
Dim X As Byte , Speed As Word , Temp1 As Word
Dim Refresh As Word
Dim Buf(128) As Word

Cls
Lcdat 1 , 1 , "Digital Oscilloscope"
Wait 1

Cls
Showpic 0 , 0 , Pic1

Do
   'Horizontal Set
   'If Pina.1 = 0 Then
      'If Speed < 1000 Then
      '    Incr Speed
      'End If
   'End If
   'If Pina.2 = 0 Then
      'If Speed > 0 Then
      '   Decr Speed
      'End If
   'End If

   'Refresh Speed Set
    'If Pina.3 = 0 Then
       'If Refresh < 4000 Then
       '   Refresh = Refresh * 2
       'End If
    'End If
    'If Pina.4 = 0 Then
       'If Refresh > 2 Then
       '   Refresh = Refresh / 2
       'End If
    'End If

    Speed = Getadc(0) : Refresh = Getadc(1)



   For X = 0 To 127
      Buf(x) = Getadc(5)
      A = A / 16 : A = - A

      'Draw Line ---___---___---___


      'Horizontal
      For Temp1 = 1 To Speed
         Waitus 1
      Next Temp1

   Next

   For X = 0 To 127
      Buf(x) = Buf(x) / 16
      Buf(x) = 64 - Buf(x)
   Next


   For X = 0 To 127
      Pset X , Buf(x) , 255
   Next


   Waitms Refresh
   'waitms 250

   Cls
   Showpic 0 , 0 , Pic1
   'Lcdat 1 , 1 , "Sweep: " ; Speed
   'Lcdat 2 , 1 , "Refresh: " ; Refresh
Loop
End

Pic1:
$bgf "Oscope.bgf"
$include "my6_8.font"

'end of file